package me.TesCZ.PtFix;

import java.util.HashMap;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;

import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;import org.bukkit.event.block.Action;
import org.bukkit.event.inventory.InventoryCloseEvent;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.plugin.java.JavaPlugin;

public class PtFix extends JavaPlugin implements Listener {
	
	private static Logger log = Logger.getLogger("AntiID");
	private Map<Block, String> inPt = new HashMap<Block, String>();
	private Map<String, Block> inPtPl = new HashMap<String, Block>();
	private Boolean clog=false;
	private String message="Two players can't use same project table in one moment.";
	private Boolean allow_ignore=true;
	private int pt_id=137;
	private int pt_subid=3;

	public void onEnable() {
		this.getServer().getPluginManager().registerEvents(this, this);
		config_load();
		LogIt("Enabled!");
	}
	
	public void onDisable(){
		inPt.clear();
		inPtPl.clear();
		LogIt("Disabled and cleared hashmaps...");
	}
		  
	public void LogIt(String x){
		log.log(Level.INFO, "[" + getDescription().getName() + " " + getDescription().getVersion() + "] " + x);
	}
    
    public void config_load(){
		reloadConfig();
	    getConfig().addDefault("log", false);
	    getConfig().addDefault("message", "Two players can't use same project table in one moment.");
	    getConfig().addDefault("allow_ignore", true);
	    getConfig().addDefault("project_table.id", 137);
	    getConfig().addDefault("project_table.subid", 3);
	     
	    getConfig().options().copyDefaults(true);
	    saveConfig();
	     
	    clog=getConfig().getBoolean("log");
	    message=getConfig().getString("message");
	    allow_ignore=getConfig().getBoolean("allow_ignore");
	    pt_id=getConfig().getInt("project_table.id");
	    pt_subid=getConfig().getInt("project_table.subid");

	    LogIt("config loaded.");
    }
    
    public Boolean canOpen(Player p){
    	if(allow_ignore){
    		if(p.isOp() || p.hasPermission("ptfix.ignore")){
    			return true;
    		}
    	}
    	return false;
    }
    
	@EventHandler(priority=EventPriority.HIGH)
	public void playerQuit(PlayerQuitEvent e){
    	String player=e.getPlayer().getName();
    	if(inPtPl.get(player) != null){
    		Block block=inPtPl.get(player);
    		inPt.remove(block);
    		inPtPl.remove(player);
    	}
	}
	
    @EventHandler(priority=EventPriority.HIGH)
    public void inventoryClose(InventoryCloseEvent e){
    	String player=e.getPlayer().getName();
    	if(inPtPl.get(player) != null){
    		Block block=inPtPl.get(player);
    		inPt.remove(block);
    		inPtPl.remove(player);
    	}
    }
	
	@EventHandler(priority=EventPriority.HIGH)
	public void openPT(PlayerInteractEvent e) {
		if (e.getClickedBlock() == null) {
			return;
		}
		
		if(e.getAction() != Action.RIGHT_CLICK_BLOCK) return;
		
		if (e.getClickedBlock().getTypeId() == pt_id && e.getClickedBlock().getData() == pt_subid){
			Player player=e.getPlayer();
			Block block=e.getClickedBlock();
			if(inPt.get(block)==null){
				inPt.put(block, player.getName());
				inPtPl.put(player.getName(), block);
			}else{
				if(!canOpen(player)){
					player.sendMessage(ChatColor.RED + message);
					if(clog){
						String player_two=inPt.get(block);
						Location l=block.getLocation();
						LogIt("Player " + player.getName() + " tried to open " + player_two + "'s Project Table at (" + l.getWorld().getName() + "; " + l.getX() + "; " + l.getY() + "; " + l.getZ() + ").");
					}
					e.setCancelled(true);
				}else{
					if(clog){
						String player_two=inPt.get(block);
						Location l=block.getLocation();
						LogIt("Operator " + player.getName() + " opened " + player_two + "'s Project Table at (" + l.getWorld().getName() + "; " + l.getX() + "; " + l.getY() + "; " + l.getZ() + ").");		
					}
				}
			}
		
		}
	}
	
}